#include "prjlibs-c/standards.h"
#include <unistd.h>
#include <fcntl.h>

#include "prjlibs-c/constants.h"
#include "fdtools.h"

int setblock(int fd, int block) {
  int const flags=fcntl(fd, F_GETFL, 0);
  int newflags;
  if (flags==-1)
    return setblock_getfl;
  if (block==0) newflags=flags| nonblock;
  else          newflags=flags&~nonblock;
  if (flags!=newflags)
    if (fcntl(fd, F_SETFL, newflags)==-1)
      return setblock_setfl;
  return setblock_success;
}
